## module Utils

```ruby
require "kaki/utils"
```

methods

* Utils.imgexist?(url)
* Utils.getfile(url, filename, max=0, ua=nil)
* Utils.key_wait
* Utils.delete\_non\_img(file_name)
* Utils.delete\_empty\_folder(folder_name = './')
* Utils.bell　　　　(only Ubuntu)
* Utils.factorial(n)
* Utils.permutation(a, b)
* Utils.combination(a, b)
* Utils.repeated_permutation(a, b)
* Utils.repeated_combination(a, b)
* Utils.generate\_random\_strings(num, string_length = nil)
* Utils.m3u8(url, fname)
* Utils.modify\_serial\_numbers(dir = Dir.pwd)
* Utils.timer(minutes)　　　　(only Ubuntu)

## Recurring decimal

```ruby
require "kaki/utils/rec_decimal"
```

methods

* Rational#to\_rec_decimal
* String#to_r

## image suffix

```ruby
require "kaki/utils/imgsuffix"
```

method

* String#imgsuffix

## n times retry

```ruby
require "kaki/utils/retry"
```
method

* Integer#times_retry(message: true, wait: 0)

## check overlapping of file names

```ruby
require "kaki/utils/check_fname_overlapping"
```
method

* File.check\_fname\_overlapping(file_name)

## nest loop (like Enumerable#map)

```ruby
require "kaki/utils/nest_loop"
```
method

* Array#nest\_loop

## add several methods in a module to a class

```ruby
require "kaki/utils/add_methods"
```
methods

* Object#add\_methods(module\_to\_include, *method\_names)
* Module#register\_all\_methods

## instance method of "p"

```ruby
require "kaki/utils/po"
```
method

* Object#po

## safe making directory

```ruby
require "kaki/utils/safe_mkdir"
```
method

* Dir.safe\_mkdir(dname)

## handle escape sequence

```ruby
require "kaki/utils/es"
```
methods

* ES.color(col, opt = nil)
* ES.csi(*args)
* ES.cmd(given)
* ES.esc(str)
* ES.clear, down, up, reset, top, home, push, pop
* ES.cursor(x, y = nil)
* ES.cursor\_r(x, y)
* ES.console\_size, cursor_position
* ES.scroll(rn = nil)
* ES.safe_scroll(n)
* ES.scroll\_up(n)
* ES.clear\_below

## 'require' all

```ruby
require "kaki/utils/all"
```


